// General Stuff

#include "general.h"

int scrw = 1024;
int scrh = 768;

bool demodone = false;

bool fullscreen = true;

bool soundon = true;

void setscrd(int w,int h) {
	scrw = w;
	scrh = h;
}

int getscrw() {
	return scrw;
}

int getscrh() {
	return scrh;
}

void setfullscreen(bool f) {
	fullscreen = f;
}

bool getfullscreen() {
	return fullscreen;
}

void setsoundon(bool s) {
	soundon = s;
}

bool getsoundon() {
	return soundon;
}

bool getdemo() {
	return demodone;
}

void enddemo() {
	demodone = true;
}

void viewReset(void)
{
	glMatrixMode(GL_PROJECTION);

	glLoadIdentity();
	gluPerspective(45.0f, scrw/(float)scrh, 0.01f, 10000.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void perspective2DBegin(const int& w, const int& h)
{
	glDisable(GL_DEPTH_TEST);

	glPushMatrix();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glPushMatrix();
	glOrtho(0, w, 0, h, 0, 1);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void perspective2DEnd(void)
{
	glPopMatrix();
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);

	viewReset();
}


// Random number generator stolen from:
//    http://remus.rutgers.edu/~rhoads/Code/code.html
// and slightly modified to suit my needs.

//static unsigned int seed = 93186752;

float randfloat() {
/* The following parameters are recommended settings based on research
   uncomment the one you want. */
//static unsigned int a = 1588635695, m = 4294967291U, q = 2, r = 1117695901;
//static unsigned int a = 1223106847, m = 4294967291U, q = 3, r = 625646750;
//static unsigned int a = 279470273, m = 4294967291U, q = 15, r = 102913196;
//static unsigned int a = 1583458089, m = 2147483647, q = 1, r = 564025558;
//static unsigned int a = 784588716, m = 2147483647, q = 2, r = 578306215;
//static unsigned int a = 16807, m = 2147483647, q = 127773, r = 2836;
//static unsigned int a = 950706376, m = 2147483647, q = 2, r = 246070895;
	//seed = a*(seed % q) - r*(seed / q);
	//double val = ((double)seed / (double)m);
	//return (float)val;
	return (float) (rand() % 25000) / 25000.0;
}


/*int randint() {
   //static unsigned int a = 1588635695, m = 4294967291U, q = 2, r = 1117695901;
   //static unsigned int a = 1223106847, m = 4294967291U, q = 3, r = 625646750;
   //static unsigned int a = 279470273, m = 4294967291U, q = 15, r = 102913196;
   static unsigned int a = 1583458089, m = 2147483647, q = 1, r = 564025558;
   //static unsigned int a = 784588716, m = 2147483647, q = 2, r = 578306215;
   //static unsigned int a = 16807, m = 2147483647, q = 127773, r = 2836;
   //static unsigned int a = 950706376, m = 2147483647, q = 2, r = 246070895;
        seed = a*(seed % q) - r*(seed / q);
        return seed;
   }

   void setseed(int num) {
    if(num < 0) num = 93186752;
        seed = num;
   }*/
