// General Header

#ifndef GENERAL
#define GENERAL

#include <GL/gl.h>
#include <GL/glu.h>

#ifdef WIN32
#include <windows.h>
#define WIN32_LEAN_AND_MEAN
#define WIN32_LEANER_AND_MEANER
#else
#include <GL/glx.h>
#include <SDL/SDL.h>
typedef int HGLRC;
typedef int HDC;
typedef int HWND;
typedef int HINSTANCE;
#define SwapBuffers(x) SDL_GL_SwapBuffers()
#endif

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "font.h"
#include "primitives.h"
#include "timer.h"
#include "Audio/sound.h"

#define scrb 32
//#define scrd scrw * scrh

#define interpolate(a,b,c) (((b) - (a)) * (c) + (a))

void setscrd(int w,int h);
int getscrw();
int getscrh();
void setfullscreen(bool f);
bool getfullscreen();
void setsoundon(bool s);
bool getsoundon();

bool getdemo();
void enddemo();

void viewReset(void);
void perspective2DBegin(const int& w, const int& h);
void perspective2DEnd(void);

extern HDC hDC;

extern float playerRewindTime;
float randfloat();

#ifdef DEBUG
extern bool debugSyncHit;
#endif

/*int randint();
   void setseed(int num);*/

#endif
