#ifndef _SOUNDA_H_
#define _SOUNDA_H_

#ifdef FMOD
#include "fmod.h"
#else
#include "minifmod.h"
#endif

//Syncs - boldly going where no hack has gone before
#define LEAD    0
#define KICK    1
#define SNARE   2

int sound_getOrder(void);
int sound_getRow(void);
int sound_isSync(int instrument);
void sound_init(void);
void sound_close(void);

#endif
