// Config File

#include "config.h"

int CALLBACK ConfigProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	switch(uMsg) {
	case WM_INITDIALOG:
		RECT rect,dlgRect;
		HWND dlg;
		dlg = GetDesktopWindow();
		if(dlg) {
			GetWindowRect(dlg,&rect);
			GetWindowRect(hwnd,&dlgRect);
			SetWindowPos(hwnd,HWND_TOP,(rect.right >> 1) - ((dlgRect.right - dlgRect.left) >> 1),(rect.bottom >> 1)-((dlgRect.bottom - dlgRect.top) >> 1),0,0,SWP_NOSIZE);
		}
		ShowWindow(hwnd,SW_SHOW);
		SetActiveWindow(hwnd);
		SetForegroundWindow(hwnd);
		SetFocus(hwnd);
		SendDlgItemMessage(hwnd,IDC_1024,BM_SETCHECK,wParam,0);
		SendDlgItemMessage(hwnd,IDC_FULLSCREEN,BM_SETCHECK,wParam,0);
		SendDlgItemMessage(hwnd,IDC_MUSIC,BM_SETCHECK,wParam,0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_LOVE:
			if(SendDlgItemMessage(hwnd,IDC_800,BM_GETSTATE,0,0) == BST_CHECKED) setscrd(800,600);
			if(SendDlgItemMessage(hwnd,IDC_640,BM_GETSTATE,0,0) == BST_CHECKED) setscrd(640,480);
			if(SendDlgItemMessage(hwnd,IDC_MUSIC,BM_GETSTATE,0,0) != BST_CHECKED) setsoundon(false);
			if(SendDlgItemMessage(hwnd,IDC_FULLSCREEN,BM_GETSTATE,0,0) != BST_CHECKED) setfullscreen(false);
			EndDialog(hwnd,0);
			break;
		case IDC_HATRED:
			enddemo();
			SendMessage(hwnd,WM_CLOSE,0,0);
			break;
		}
		break;
	case WM_DESTROY:
		SendMessage(hwnd,WM_CLOSE,0,0);
		break;
	case WM_CLOSE:
		EndDialog(hwnd,0);
		break;
	}
	return 0;
}
